Index: pgadmin/include/schema/pgColumn.h
===================================================================
--- pgadmin/include/schema/pgColumn.h	(révision 8245)
+++ pgadmin/include/schema/pgColumn.h	(copie de travail)
@@ -95,6 +95,8 @@
     bool GetSystemObject() const { return colNumber < 0; }
     wxString GetSql(ctlTree *browser);
 	wxString GetCommentSql();
+	wxString GetStorageSql();
+	wxString GetAttstattargetSql();
     wxString GetPrivileges();
     wxString GetHelpPage(bool forCreate) const { return wxT("pg/sql-altertable"); }
 
Index: pgadmin/schema/pgTable.cpp
===================================================================
--- pgadmin/schema/pgTable.cpp	(révision 8245)
+++ pgadmin/schema/pgTable.cpp	(copie de travail)
@@ -304,11 +304,18 @@
                     prevComment = column->GetComment();
 
                     // Whilst we are looping round the columns, grab their comments as well.
-                    // Perhaps we should also get storage types here?
                     colDetails += column->GetCommentSql();
                     if (colDetails.Length() > 0)
                         if (colDetails.Last() != '\n')
                             colDetails += wxT("\n");
+                    colDetails += column->GetStorageSql();
+                    if (colDetails.Length() > 0)
+                        if (colDetails.Last() != '\n')
+                            colDetails += wxT("\n");
+                    colDetails += column->GetAttstattargetSql();
+                    if (colDetails.Length() > 0)
+                        if (colDetails.Last() != '\n')
+                            colDetails += wxT("\n");
 
                     colCount++;
                     columnPrivileges += column->GetPrivileges();
Index: pgadmin/schema/pgColumn.cpp
===================================================================
--- pgadmin/schema/pgColumn.cpp	(révision 8245)
+++ pgadmin/schema/pgColumn.cpp	(copie de travail)
@@ -102,11 +102,10 @@
                     + wxT(" DROP COLUMN ") + GetQuotedIdentifier() + wxT(";")
                     
                     + wxT("\n\nALTER TABLE ") + GetQuotedFullTable()
-                    + wxT(" ADD COLUMN ") + GetQuotedIdentifier() + wxT(" ") + GetQuotedTypename()
+                    + wxT(" ADD COLUMN ") + GetQuotedIdentifier() + wxT(" ")
+                    + GetQuotedTypename() + wxT(";\n");
                     
-                    + wxT(";\nALTER TABLE ")+ GetQuotedFullTable()
-                    + wxT(" ALTER COLUMN ") + GetQuotedIdentifier()
-                    + wxT(" SET STORAGE ") + GetStorage() + wxT(";\n");
+                sql += GetStorageSql();
 
                 if (GetNotNull())
                     sql += wxT("ALTER TABLE ") + GetQuotedFullTable()
@@ -116,10 +115,7 @@
                     sql += wxT("ALTER TABLE ") + GetQuotedFullTable()
                         + wxT(" ALTER COLUMN ") + GetQuotedIdentifier()
                         + wxT(" SET DEFAULT ") + GetDefault() + wxT(";\n");
-                if (GetAttstattarget() >= 0)
-                    sql += wxT("ALTER TABLE ") + GetQuotedFullTable()
-                        + wxT(" ALTER COLUMN ") + GetQuotedIdentifier()
-                        + wxT(" SET STATISTICS ") + NumToStr(GetAttstattarget()) + wxT(";\n");
+                sql += GetAttstattargetSql();
 
                 size_t i;
                 for (i=0 ; i < variables.GetCount() ; i++)
@@ -149,6 +145,30 @@
     return commentSql;
 }
 
+wxString pgColumn::GetStorageSql()
+{
+    wxString storageSql;
+
+    if (!GetStorage().IsEmpty())
+        storageSql = wxT("ALTER TABLE ")+ GetQuotedFullTable()
+                    + wxT(" ALTER COLUMN ") + GetQuotedIdentifier()
+                    + wxT(" SET STORAGE ") + GetStorage() + wxT(";\n");
+    
+    return storageSql;
+}
+
+wxString pgColumn::GetAttstattargetSql()
+{
+    wxString attstattargetSql;
+
+    if (GetAttstattarget() >= 0)
+        attstattargetSql = wxT("ALTER TABLE ") + GetQuotedFullTable()
+                         + wxT(" ALTER COLUMN ") + GetQuotedIdentifier()
+                         + wxT(" SET STATISTICS ") + NumToStr(GetAttstattarget()) + wxT(";\n");
+    
+    return attstattargetSql;
+}
+
 wxString pgColumn::GetPrivileges()
 {
     wxString privileges;
